/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
// Company       : 人о·Ƽ޹˾
//                 http://xiaomeige.taobao.com
// Web           : http://www.corecourse.cn
// 
// Create Date   : 2022/02/21 00:00:00
// Module Name   : ad7606c_ddr3_rgmii
// Description   : AD7606cݲɼ̫ϵͳ
// 
// Dependencies  : 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
/////////////////////////////////////////////////////////////////////////////////
`timescale 1ns / 1ps
module ad7606C_ddr3_rgmii(
    Clk,
    reset_n,
	
    //DDR3 Interface
    // Inouts
    ddr3_dq,
    ddr3_dqs_n,
    ddr3_dqs_p,
    // Outputs
    ddr3_addr,
    ddr3_ba,
    ddr3_ras_n,
    ddr3_cas_n,
    ddr3_we_n,
    ddr3_reset_n,
    ddr3_ck_p,
    ddr3_ck_n,
    ddr3_cke,
    ddr3_cs_n,
    ddr3_dm,
    ddr3_odt,
    //AD7606c
	ad7606_cs_n_o, 
	ad7606_rd_n_o, 
	ad7606_busy_i, 
	ad7606_db_i,   
	ad7606_os_o,   
	ad7606_reset_o,
	ad7606_convst_o,
	
	rgmii_rx_clk_i,
    rgmii_rxd,
    rgmii_rxdv,
    rgmii_tx_clk,
    rgmii_txd,
    rgmii_txen,
    
    eth_reset_n,
    led
	 );
	//ʱӺ͸λź
	input Clk;
	input reset_n;
	
	//̫ź
    //eth_rx
    input         rgmii_rx_clk_i;
    input  [3:0]  rgmii_rxd;
    input         rgmii_rxdv;
    //eth_tx
    output        rgmii_tx_clk;
    output  [3:0] rgmii_txd;
    output        rgmii_txen;
    output        eth_reset_n;
    
    //ADCź
    output         ad7606_cs_n_o;         
	output         ad7606_rd_n_o;         
	input          ad7606_busy_i;         
	input   [15:0] ad7606_db_i;           
	output  [2:0]  ad7606_os_o;           
	output         ad7606_reset_o;        
	output         ad7606_convst_o;
    
    //LED
    output [1:0]led;
    
    //DDR3 Interface
    // Inouts
    inout  [15:0]ddr3_dq;
    inout  [1:0] ddr3_dqs_n;
    inout  [1:0] ddr3_dqs_p;
    // Outputs
    output [13:0]ddr3_addr;
    output [2:0] ddr3_ba;
    output       ddr3_ras_n;
    output       ddr3_cas_n;
    output       ddr3_we_n;
    output       ddr3_reset_n;
    output [0:0] ddr3_ck_p;
    output [0:0] ddr3_ck_n;
    output [0:0] ddr3_cke;
    output [0:0] ddr3_cs_n;
    output [1:0] ddr3_dm;
    output [0:0] ddr3_odt;
  
    //eth_rx
    wire [7:0]payload_dat_o;
    wire payload_valid_o;
    wire one_pkt_done;
    //pll
    wire clk_100M;
    wire clk_200M; //200MʱӹDDR3ʹ
    wire udp_gmii_rst_n;
    wire pll_locked;
    //rxfifo    
    wire [7:0]rxdout;
    wire clk125m_o;
    wire rx_empty;
    wire fifo_rd_req;
    //rxcmd
    wire cmdvalid_0;
    wire [7:0]address_0;
    wire [31:0]cmd_data_0; 
  
    wire [7:0]ChannelSel;
    wire [31:0]DataNum;
    wire [31:0]ADC_Speed_Set;   
    wire sample_en;
    
    //txFIFO
    wire [7:0]dout;
    wire [14:0]rd_data_count;
    //txsend
    wire tx_done;        
    
    //DDR3
    wire ddr3_init_done;   //DDR3ʼɱ־ź
    wire ddr3_rst_n;
     
    wire [15:0]ad_out;
    wire ad_out_valid;
    
    wire [15:0] rdfifo_dout;
	wire	payload_req_o; 
    
    wire wrfifo_clr;
    wire wrfifo_full;
    wire rdfifo_clr;
    wire rdfifo_empty;
    wire rdfifo_rden;
    wire [15:0] eth_fifo_wrdata;
    wire eth_fifo_wrreq;
    wire [9:0] eth_fifo_usedw;
	
	wire eth_fifo_tx_empty;
    wire tx_en_pulse;
    wire [15:0]lenth_val;
    
    wire [7:0]adc_data_flag;
    wire [15:0]adc_data_mult_ch;

    wire gmii_tx_clk;
    wire [7:0]gmii_txd;
    wire gmii_txen;
    wire [7:0] gmii_rxd;
    wire gmii_rxdv;

    wire req0;
    reg req1,req2,req3,req4;
    reg RestartReq;

    always@(posedge clk_100M) begin
        req1 <= req0;
        req2 <= req1;
        req3 <= req2;
        req4 <= req3;
        RestartReq <= req4;
    end

    //̫λ
    assign eth_reset_n = 1;
ila_0 your_instance_name (
	.clk(gmii_tx_clk), // input wire clk
	.probe0(gmii_txd), // input wire [7:0]  probe0  
	.probe1(gmii_txen), // input wire [0:0]  probe1 
	.probe2(gmii_rxd), // input wire [7:0]  probe2 
	.probe3(gmii_rxdv) // input wire [0:0]  probe3
);
	 
    parameter local_mac = 48'h00_0a_35_01_fe_c0;
    parameter local_ip = 32'hc0_a8_00_02;
    parameter local_port = 16'd5000;
   
    assign ddr3_rst_n = pll_locked;
   
   //led[0] ໷źΪߣ˵໷ʱ
   //led[1] DDR3ʼɱʶźţΪߣ˵DDR3Ѿɳʼ
   assign led = {ddr3_init_done,pll_locked};

    wire rgmii_rx_clk;
    wire gmii_rx_clk; 
    wire        reset_p; 
   mmcm mmcm
   (
    // Clock out ports
    .clk_out1(clk_200M),     // output clk_out1
    .clk_out2(clk_100M),
    // Status and control signals
    .resetn(reset_n), // input resetn
    .locked(pll_locked),       // output locked
   // Clock in ports
    .clk_in1(Clk));      // input clk_in1

  clk_wiz_0 eth_clk
   (
    // Clock out ports
    .clk_out1(rgmii_rx_clk),     // output clk_out1
   // Clock in ports
    .clk_in1(rgmii_rx_clk_i));      // input clk_in1

    assign reset_p = ~reset_n;
    rgmii_to_gmii rgmii_to_gmii(
        .reset(reset_p),
      
        .rgmii_rx_clk(rgmii_rx_clk),
        .rgmii_rxd(rgmii_rxd),
        .rgmii_rxdv(rgmii_rxdv),
      
        .gmii_rx_clk(gmii_rx_clk),
        .gmii_rxdv(gmii_rxdv),
        .gmii_rxd(gmii_rxd),
        .gmii_rxer( )
    );
         
    eth_udp_rx_gmii eth_udp_rx_gmii (
        .reset_n (reset_n),
        
        .gmii_rx_clk(gmii_rx_clk),  
        .gmii_rxdv(gmii_rxdv),
        .gmii_rxd(gmii_rxd),
        //out clk
        .clk125m_o(clk125m_o),
       
        .local_mac(local_mac),
        .local_ip(local_ip),
        .local_port(local_port),
        
        .exter_mac(),
        .exter_ip(),
        .exter_port(),
        
        .rx_data_length(),
        .data_overflow_i(),
        
        .payload_valid_o(payload_valid_o),
        .payload_dat_o(payload_dat_o),
        
        .one_pkt_done(one_pkt_done),
        .pkt_error(),
        .debug_crc_check()   
    ); 

    fifo_rx fifo_rx (    
        .rst(!reset_n), // input wire rst
        .wr_clk(clk125m_o), // input wire wr_clk
        .rd_clk(clk_100M), // input wire rd_clk
        .din(payload_dat_o), // input wire [7 : 0] din
        .wr_en(payload_valid_o), // input wire wr_en
        .rd_en(fifo_rd_req), // input wire rd_en
        .dout(rxdout), // output wire [7 : 0] dout
        .full(), // output wire full
        .empty(rx_empty) // output wire empty
		  );

    eth_cmd eth_cmd (
        .clk(clk_100M),
        .reset_n(reset_n),
        .fifo_rd_req(fifo_rd_req),
        .rx_empty(rx_empty),
        .fifodout(rxdout),
        .cmdvalid(cmdvalid_0),
        .address(address_0),
        .cmd_data(cmd_data_0)
        );
        
	 reg RestartReq_0_d0,RestartReq_0_d1;
	 reg [31:0]Number_d0,Number_d1;
	 
	 always@(posedge clk125m_o)
	 begin
		Number_d0 <= DataNum;
		Number_d1 <= Number_d0;
		
		RestartReq_0_d0 <= RestartReq;
		RestartReq_0_d1 <= RestartReq_0_d0;
	 end
		  
	cmd_rx cmd_rx_0(
		.clk(clk_100M),
		.reset_n(reset_n),
		.cmdvalid(cmdvalid_0),
		.cmd_addr(address_0),
		.cmd_data(cmd_data_0),
		
		.ChannelSel(ChannelSel),
		.DataNum(DataNum),
		.ADC_Speed_Set(ADC_Speed_Set),
		.RestartReq(req0)
//		.RestartReq(RestartReq)
	);
	wire ad_sample_en;
      
	//AD7606ģ
    ad7606C_driver ad7606C_driver(
        .Clk(clk_100M),
        .Reset_n(reset_n),
        .Go(1),
        .Speed_Set(ADC_Speed_Set),
        .Conv_Done(),
        .ad7606_cs_n_o(ad7606_cs_n_o), 
        .ad7606_rd_n_o(ad7606_rd_n_o), 
        .ad7606_busy_i(ad7606_busy_i), 
        .ad7606_db_i(ad7606_db_i), 
        .ad7606_os_o(ad7606_os_o), 
        .ad7606_reset_o(ad7606_reset_o), 
        .ad7606_convst_o(ad7606_convst_o), 
		.data_flag(adc_data_flag),
		.data_mult_ch(adc_data_mult_ch),
        .data1(),
        .data2(), 
        .data3(), 
        .data4(), 
        .data5(), 
        .data6(), 
        .data7(), 
        .data8()
    );	
    state_ctrl state_ctrl(
        .clk(clk_100M),
        .reset(~reset_n),
        .ddr3_init_done(ddr3_init_done),  //DDRʼɱ־ź
        .start_sample(RestartReq), //ADCɼ־ź
        .set_sample_num(DataNum),//Ҫɼ32λ4G
        .rdfifo_empty(rdfifo_empty), //DDR˫˿ģFIFOΪձ־ź
        .rdfifo_dout(rdfifo_dout), //DDRж16λ
        .wrfifo_full(wrfifo_full),  //DDRдFIFOΪ־ź
        .adc_ch_sel(ChannelSel),  
        .adc_data_flag(adc_data_flag),	 
        .wrfifo_clr(wrfifo_clr),  //DDR˫˿ģдFIFOź
        .rdfifo_clr(rdfifo_clr),  //DDR˫˿ģĶFIFOź
        .rdfifo_rden(rdfifo_rden), //DDR˫˿ģĶʹź
        .ad_sample_en(ad_sample_en),   //ADCʹܱ־ź
        .eth_fifo_usedw(eth_fifo_usedw),
        .eth_fifo_wrreq(eth_fifo_wrreq), //̫fifo_txдź
        .eth_fifo_wrdata(eth_fifo_wrdata)    //Ҫ̫fifo_txд
      );

  //DDR3˫˿ģ
  ddr3_ctrl_2port #(
    .DW            (16),
    .WR_ADDR_BEGIN (0),//洢дʼλ
    .WR_ADDR_END   (128*1024*1024-1),//洢дֹλ
    .RD_ADDR_BEGIN (0),//洢Ķʼλ
    .RD_ADDR_END   (128*1024*1024-1)//洢Ķֹλ
  )
  ddr3_ctrl_2port(
    .ddr3_clk200m  (clk_200M      ),
    .ddr3_rst_n    (ddr3_rst_n    ),
    .ddr3_init_done(ddr3_init_done),
    .wrfifo_clr    (wrfifo_clr    ),
    .wrfifo_clk    (clk_100M    ),
    .wrfifo_wren   ((adc_data_flag & ChannelSel)  && ad_sample_en  ),
    .wrfifo_din    (adc_data_mult_ch ),
    .wrfifo_full   (wrfifo_full   ),
    .wrfifo_wr_cnt (  ),
    //rd_fifo Interface
    .rdfifo_clr    (rdfifo_clr    ),
    .rdfifo_clk    (clk_100M       ),
    .rdfifo_rden   (rdfifo_rden   ),
    .rdfifo_dout   (rdfifo_dout   ),
    .rdfifo_empty  (rdfifo_empty  ),
    .rdfifo_rd_cnt (              ),
    // Inouts
    .ddr3_dq       (ddr3_dq       ),
    .ddr3_dqs_n    (ddr3_dqs_n    ),
    .ddr3_dqs_p    (ddr3_dqs_p    ),
    // Outputs      
    .ddr3_addr     (ddr3_addr     ),
    .ddr3_ba       (ddr3_ba       ),
    .ddr3_ras_n    (ddr3_ras_n    ),
    .ddr3_cas_n    (ddr3_cas_n    ),
    .ddr3_we_n     (ddr3_we_n     ),
    .ddr3_reset_n  (ddr3_reset_n  ),
    .ddr3_ck_p     (ddr3_ck_p     ),
    .ddr3_ck_n     (ddr3_ck_n     ),
    .ddr3_cke      (ddr3_cke      ),
    .ddr3_cs_n     (ddr3_cs_n     ),
    .ddr3_dm       (ddr3_dm       ),
    .ddr3_odt      (ddr3_odt      )
  );
  
  fifo_tx fifo_tx (      
      .rst(req0||req1||req2||req3||req4),                      // input wire rst
      .wr_clk(clk_100M),                // input wire wr_clk
      .rd_clk(clk125m_o),                // input wire rd_clk
      .din({eth_fifo_wrdata[7:0],eth_fifo_wrdata[15:8]}),                      // input wire [15 : 0] din
      .wr_en(eth_fifo_wrreq),                  // input wire wr_en
      .rd_en(payload_req_o),                  // input wire rd_en
      .dout(dout),                    // output wire [7 : 0] dout
      .full(),                    // output wire full
      .empty(eth_fifo_tx_empty),        // output wire empty
      .wr_data_count(eth_fifo_usedw),  // output wire [9 : 0] wr_data_count
      .rd_data_count(rd_data_count),
      .wr_rst_busy(),      // output wire wr_rst_busy
      .rd_rst_busy()      // output wire rd_rst_busy
   );
 
  eth_send_ctrl eth_send_ctrl(
      .clk125M(clk125m_o),     
      .reset_n(reset_n),  //ģĸλź
      .eth_tx_done(tx_done),    //̫һź
      .restart_req(RestartReq_0_d1),
      .fifo_rd_cnt(rd_data_count), //FIFOжȡݸ
      .total_data_num(Number_d1),  //Ҫ͵
      .pkt_tx_en(tx_en_pulse),   //̫ʹź
      .pkt_length(lenth_val)  //̫Ҫ͵ݵĳ
   ); 
   
  eth_udp_tx_gmii eth_udp_tx_gmii(
      .clk125M(clk125m_o),
      .reset_n(reset_n),
               
      .tx_en_pulse(tx_en_pulse),
      .tx_done(tx_done),
                     
      .dst_mac(48'hFF_FF_FF_FF_FF_FF),
      .src_mac(48'h00_0a_35_01_fe_c0),  
      .dst_ip(32'hc0_a8_00_03),
      .src_ip(32'hc0_a8_00_02),	
      .dst_port(16'd6102),
      .src_port(16'd5000),
                     
      .data_length(lenth_val),
      .payload_req_o (payload_req_o),
      .payload_dat_i (dout),
  
      .gmii_tx_clk   (gmii_tx_clk),	
      .gmii_txen     (gmii_txen),
      .gmii_txd      (gmii_txd)
  );

   gmii_to_rgmii gmii_to_rgmii(
       .reset_n(reset_n),
       .gmii_tx_clk(gmii_tx_clk),
       .gmii_txd(gmii_txd),
       .gmii_txen(gmii_txen),
       .gmii_txer(1'b0),
      
       .rgmii_tx_clk(rgmii_tx_clk),
       .rgmii_txd(rgmii_txd),
       .rgmii_txen(rgmii_txen)
   );
endmodule